<?
dl((PHP_OS=="WINNT"||PHP_OS=="WIN32")?"php_sqlite.dll":"sqlite.so");

class CSqlite
{
	var $Record = array();
	var $Fields = array();
	var $Query;
	var $Row;

	var $Errno = 0;
	var $Error = "";
	var $dbLink = 0;
	var $Result = 0;
	
	function clone()
	{
		return new CSqlite();
	}

	function open($dbName)
	{
		$this->dbLink = sqlite_open($dbName,0666,$this->Error);
	}

	function query($Query,$Debug=0)
	{
		if(!($Query=trim($Query))) return;
		$Query=str_replace("`","",$Query);
		
		if (strstr($Query,"SHOW KEYS")) 
		{
			$ar=explode("FROM",$Query);
			$Query="SELECT * FROM sys_keys WHERE Tbl='".trim($ar[1])."'";
		}
		
		if (strstr($Query,"SHOW FIELDS")) 
		{
			$ar=explode("FROM",$Query);
			$Query="SELECT * FROM sys_fields WHERE Tbl='".trim($ar[1])."'";
		}
		
		$this->Query = $Query;
		$this->Result = sqlite_query($this->dbLink,$Query);
		
		$ok=($Debug>0);
		if($Debug>=0 && !$this->Result)
		{
			$this->error();
			if(_DEBUG_) 
			{
				$Query = str_replace("FORM","<B><U>FORM</U></B>",$Query);
				$ok=1;
			}
		}
		
		if($ok)
		{
			print("<br><div style='font-family:verdana;font-size:12px;'>Debug: query = <b>$Query</b><br>\n");
			$this->error();
			if(!$this->Result)
				print("<span style='color:#ffff00;background-color:#ff0000'><b>Error: [$this->Errno] $this->Error </b></span>\n");
			else
				print("Rows: ".$this->num_rows()." <br>\n");
			
			print("<br><br></div>");
		}
		
		$this->Row = 0;
		$this->Fields=array();

		if ($n=$this->num_fields())
			for ($i=0; $i<$n; $i++)
				$this->Fields[]=sqlite_field_name($this->Result,$i); 

		return($this->Result);
	}
	
	function record($numeric=true)
	{
		foreach($this->Record as $i=>$v)
		{
			if($numeric)
			{
				if(is_int($i)) $ret[$i] = $v;
			}
			else
			{
				if(!is_int($i)) $ret[$i] = $v;
			}
		}
		return($ret);
	}

	function error()
	{
		$this->Errno = sqlite_last_error($this->dbLink);
		$this->Error = sqlite_error_string($this->Errno);
		return($this->Error);
	}

	function next()
	{
		if(!$this->Result) return 0;
		$this->Record = @sqlite_fetch_array($this->Result);
		
		if ($status = is_array($this->Record)) 
			foreach($this->Record as $i=>$v) $this->Record[$i]=stripslashes($v);

		$this->Row++;
		return $status;
	}

	function insert_id()
	{
		return sqlite_last_insert_rowid($this->dbLink);
	}
	
	function num_rows()
	{
		return ($r=$this->Result) ? @sqlite_num_rows($r) : 0;
	}
	
	function affected_rows()
	{
		return $this->num_rows();
	}

	function num_fields()
	{
		return ($r=$this->Result) ? @sqlite_num_fields($r) : 0;
	}

	function eof()
	{
		return( $this->Row>$this->num_rows());
	}

	function close()
	{
		return sqlite_close($this->dbLink);
	}

	function dump()
	{
		$buf ="<table border=0 cellpadding=3 cellspacing=1 bgcolor=#000000 style='font-family:verdana;font-size:10px;'>";
		$buf.="<tr valign=middle bgcolor=#D0D0D0><th style='font-size:12px;'>Rows: ".$this->num_rows()."</th><th style='font-size:12px;' align=left colspan=".($this->num_fields()-1)."><font color=#008000>".$this->Query."</font></th></tr>";
		if ($this->next())
		{
			$buf.="<tr valign=baseline bgcolor=#E0E0E0>";
			foreach($this->record(0) as $i=>$v) $buf.="<td bgcolor=#E0E0E0><b>$i</b></td>";
			$buf.="</tr>";
			do
			{
				$buf.="<tr valign=baseline bgcolor=#EFEFEF>";
				foreach($this->record(0) as $v) $buf.="<td>"._H($v)."</td>";
				$buf.="</tr>";
			}
			while ($this->next());
		}

		$buf.="</table>";
		echo $buf;
	}
}
?>