<?
define("PAGE",basename($PATH_TRANSLATED));
define("_DEBUG_",get_cfg_var("DeveloperServer"));
include_once("defines.php");

function redirect($url='.') 
{ 
	header("Location: $url"); 
	exit(); 
}

function userOutputHandler(&$buffer) 
{ 
	if (ereg("(error</b>:)(.+)(<br)", $buffer, $regs))
  {
  	trigger_error($regs[2],E_USER_ERROR);
		redirect("index.php");
	}
  else
		return $buffer;
} 

function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars) 
{
	if(error_reporting()!=0) 
	{
		$errortype = array 
		(
			E_ERROR           => "ERROR",
			E_WARNING         => "WARNING",
			E_PARSE           => "PARSING ERROR",
			E_USER_ERROR      => "USER ERROR",
			E_USER_WARNING    => "USER WARNING",
		);
		
		if ($errortype[$errno])
		{
			$err=str_repeat("=",80)."\r\n[".date("d-m-Y H:i:s")."] ".$errortype[$errno].": {".PAGE."?".$GLOBALS[QUERY_STRING]."} $errmsg\r\n";
			$ar=debug_backtrace(); 
			array_shift($ar);
			if (($errno==E_USER_ERROR) || ($errno==E_USER_WARNING)) array_shift($ar);
			foreach($ar as $i=>$v) $err.="\t ".$v["function"]."([".implode("],[",$v[args])."]) in ".$v["file"]." on line ".$v["line"]."\r\n";
			
			error_log($err,3,ini_get("error_log"));
		}
	}
}
set_error_handler("userErrorHandler");
		
if (!get_cfg_var("session.auto_start") && $SID!="no")
{
	if ($SID) session_id($SID);
	session_start();
	if (!$SID) $SID=session_id();
}

if (_DEBUG_)
{
	function dev()
	{
		ob_start();
		$start=0;
		$c = func_num_args();
		if (substr(func_get_arg(0),0,5)=="file:") 
		{
			$fp=fopen(substr(func_get_arg(0),5),"a");
			$start=1;
		}

		for ($i=$start; $i<$c; $i++) 
		{
			$o=func_get_arg($i);
			
			if ($i==0)
				if ((string)$o=="@") 
				{
					$div="</div>";
					$pre="</xmp>";
					print("<div style='position:absolute;top:0;left:0;'><xmp>");
					continue; 
				}
				elseif ($o=="-")	
					continue; 
				else 
				{ 
					$pre="</xmp>";
					print("<xmp>");
				}

			if (is_string($o) && $o=="die")
				die("<b>dev die process</b>$pre$div</div>");
			elseif (is_object($o))
				if ($o) print_r($o); else print("null object [arg:$i]\n");
			elseif (is_array($o))
				if ($o) print_r($o); else print("empty array [arg:$i]\n");
			elseif (is_string($o))
				print(trim($o)."\n");
			elseif (!isset($o))
				print("undefined variable [arg:$i]\n");
			elseif (is_resource($o))
				print("$o [".get_resource_type($o)."]\n");
			else
				var_dump($o);

			if (!$pre && !$fp) print("<br>");
		}
		if ($fp)
		{
			fputs($fp,ob_get_contents());
			ob_end_clean();
			fclose($fp);
		}
		else
		{
			if ($pre) print("$pre$div"); else print("<br>");
			ob_end_flush();
		}
	}
}
else
{
	function dev() 
	{
	}
}

function _H($s,$br=0)
{
	if ($br) $s=str_replace(">",">\n",$s);
	return htmlspecialchars($s);
}

function load_ini($fname) 
{
	$lines=file($fname);
  $section = 'Default';
  for($i=0; $i<count($lines); ++$i) 
  {
    /* Section */
    if(preg_match("'\s*\[([^\]]+)\]\s*'i" , $lines[$i], $matches))
      $section = $matches[1];
    /* Entry */
    elseif(preg_match("/\s*(\S+)\s*=\s*(.*)\s*(?:#.*)?/", $lines[$i], $matches))
      $result[$section][$matches[1]] = trim($matches[2]);
  }
  return $result;
}

function save_ini($fname,$cfg)
{
	$fp=fopen($fname,"w");
	foreach($cfg as $section=>$data)
	{
		fputs($fp,"[$section]\r\n");
		foreach($data as $n=>$v) fputs($fp,"$n = $v\r\n");
		fputs($fp,"\r\n");
	}
	fclose($fp);
} 

function make_url($ar2="")
{
	$ar1=$_GET;
	settype($ar1,"array");
	if ($ar2)
		settype($ar2,"array");
	else
		$ar2=array();
	
	$ar=array_merge($ar1,$ar2);
	foreach($ar as $i=>$v) 
		if (is_array($v))
			foreach($v as $ii=>$vv)		
				$s.="&$i[$ii]=$vv";
		else
			$s.="&$i=$v";
	if ($s) $s="?".substr($s,1);
	return PAGE.$s;
}

function split_name($name,$size=40)
{
	$len=0; $ret="";
	$ar=explode("/",$name);
	foreach($ar as $i=>$v)
	{
		$ret.="$v/";
		$len+=strlen("$v/");
		if ($len>$size) { $ar[$i]="<br>".$ar[$i]; $ret.="<br>"; $len=0; }
	}
	return implode("/",$ar);
}

if ($_SERVER[HKEY])
{
	session_register("DIRECT_BROWSER");
	if (!$DIRECT_BROWSER) $DIRECT_BROWSER=$HTTP_DIRECT_BROWSER;
	if (!$DIRECT_BROWSER) 
	{
		header("HTTP/1.0 404 Not Found");
		exit();
	}
}

define("_DEMOCD_",_MODE_=="CD" && _DEMO_);

if (file_exists("../publish.ini")) $CFG=load_ini("../publish.ini");
?>